Loading a PostGIS View is very slow
Status: Closed

Priority: Low

Assignee: Gavin Macaulay -

Category: Vectors

Affected QGIS version: Regression?: No

Operating System: RedHat Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed

Crashes QGIS or corrupts data: Copied to github as #: 10536

Description

The loading of a [[PostGIS]] view is much slower than the loading of a table with the same structure.

The simple view 

CREATE OR REPLACE VIEW geo_gemeinden_v AS 

 SELECT oid, ogc_fid, wkb_geometry, name, gem_bfs, gmde_name, gmde_nr, bzrk_nr, eg_nr, plz, ktn_nr, new_date, archive_date,

archive FROM geo_gemeinden;

needs 24secs to load. The table geo_gemeinden with the same structure less than 1sec.

For testing purposes I attach the dump of geo_gemeinden

History

#1 - 2006-12-22 04:11 AM - Redmine Admin

Please excuse but the mentioned file could not be attached due to size.

#2 - 2006-12-23 12:31 AM - Gavin Macaulay -

Qgis has to do a lot more work when loading views. It has to work out which table/column each column in the view comes from, and then choose a column

to use as a unique key. This entails working out that information for all views in the database. If you have a lot of views in the database, this may take some

time.

Nothwithstanding all of that, 24 seconds is a lot longer than 1 second, and this area clearly needs some more work, but it's unlikely to happen before we

release 0.8.

#3 - 2007-01-30 06:28 AM - Redmine Admin

Now release 0.8 is released and I want to ask for the state of solution. My DB has more than 300 Geo-Layers and much more Geo-Views. QGIS takes a

very long time to load a view.

#4 - 2007-02-16 10:59 PM - Gavin Macaulay -

A potential speed-up has been committed to head (commit:2a35478a (SVN r6611)). Please test if you can. If it works, I'll port it to the 0.8.1 branch.

2024-04-27 1/2



#5 - 2007-02-18 11:55 AM - Gavin Macaulay -

Hmm. It's actually slower :(

#6 - 2007-03-13 01:03 AM - Redmine Admin

I'll come back to my qustion about the state of solution. The slowness of views is a real and essential problem. I'm not able to use QGIS in our enterprise

environment due to the view problem.

Horst Duester

SO!GIS Kanton Solothurn

#7 - 2007-03-13 12:24 PM - Gavin Macaulay -

Nothing more has been done about this. I'd actually forgotten about it! I'll have another go this weekend.

Gavin

#8 - 2007-07-15 01:40 AM - Marco Hugentobler

- Status changed from Open to Closed

- Resolution set to fixed

A fix for this is in commit:5324e893 (SVN r7072). It also adresses column renaming with 'AS' and views that refer to other views.

#9 - 2009-08-22 12:45 AM - Anonymous

Milestone Version 0.9 deleted
